
/* Compatible models:
 *      - 
 *      - 
 *      - 
 *      - 
 *      - 
 *      - 
 *      - 
 */

function Screen() {
}

Screen.prototype = new BasicScreenController();
Screen.prototype.constructor = Screen();


// Reference to "this" that won't get clobbered by some other "this"
//Screen.prototype.self = this;
Screen.prototype.name = "PCB_RS232";

/* 
 * Timers use
 * if (timer = * ) it will load if (timer = 0) it won't load
 * Once init is called, timeouts references are stored here
 */
Screen.prototype.timers = {
    power : 1,
    channel : 0,
    schedule : 1
}

Screen.prototype.maxAttempts = {
    power : 1,
    channel : 0,
    schedule : 1
};

/******************************** PORT ********************************/    

//Conf
Screen.prototype.portValues = {
        name : '',
        config : {
                baudRate : 115200,
                dataBits : 8,
                stopBits : 1
        },
        parser : {
            type : 'byteLength' ,
            delimiter : 4
        }   
}

//PROTOTYPING
/******************************** INIT PROTOTYPING ********************************/
Screen.prototype.formatRemoteId = function ( id ) {
    return Buffer.from ( ( "00" + id.toString(16)).substr(-2) , 'hex');
};

Screen.prototype.loadDriver = function ( platform ) {
    if  ( typeof RS232_driverController !== "function" ){
        eval('eval')(fs.readFileSync('./app/screenDrivers/RS232.js')+'');
    }

    return new RS232_driverController ();
};

Screen.prototype.loadPortValues = function () {} ;


/******************************** STATUS PROTOTYPING ********************************/

Screen.prototype.generatePowerQuerry = function (){
    var command = Buffer.from ( 'AE04010A' , 'hex');
    return command;
}

Screen.prototype.translatePowerQuerry = function ( data ){
    this.status.lastCMD = data.toString('hex');
    //console.log ( new Date() + ' - ' + this.name + ', screen: '+ this.data.id + " : Result check power status: " + this.status.lastCMD );
    if (data.includes( Buffer.from ('EF040101', 'hex') ) ){
        this.status.power = 1;
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.power = this.maxAttempts.power;
    }else if (data.includes( Buffer.from ('EF040100', 'hex') ) ){
        this.status.power = 0;
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.power = this.maxAttempts.power;
    }else{
        if ( !(this.attemptsCounter.power < this.maxAttempts.power) ){
            this.status.power = -1;
            this.status.tstamp = Math.floor(new Date().getTime()/1000);
        }
    }
    return;
};



Screen.prototype.endPowerQuerry = function (){
    return;
};


/******************************** CHANNEL PROTOTYPING ********************************/

Screen.prototype.generateChannelQuerry = function (){
    var command = Buffer.from ( 'AE04020A' , 'hex');
    return command;
};


Screen.prototype.translateChannelQuerry = function ( data ){
    //no channel control
    if (data.includes( Buffer.from ('EF040202', 'hex') )){
        this.status.channel = 'HDMI';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes( Buffer.from ('EF040201', 'hex') )){
        this.status.channel = 'VGA';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes( Buffer.from ('EF040200', 'hex') )){
        this.status.channel = 'OTHER';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else{
        if ( !(this.attemptsCounter.power < this.maxAttempts.power) ){
            this.status.channel = 'Unknown';
            this.status.tstamp = Math.floor(new Date().getTime()/1000);
        }
    }
    return;
};


Screen.prototype.endChannelQuerry = function (){};
    
/******************************** SCHEDULE PROTOTYPING ********************************/
Screen.prototype.generateScheduleQuerry  = function (){ return ""; };
Screen.prototype.translateScheduleQuerry = function ( data ){ return; };
Screen.prototype.endScheduleQuerry       = function (){
        this.attemptsCounter.schedule = this.maxAttempts.schedulereturn;
        return;
    };

/******************************** MISC PROTOTYPING ********************************/
Screen.prototype.generateOnQuerry  = function (){
    var command = Buffer.from ( '01302A30413043024332303344363030303103180D' , 'hex');
    return command;
};
Screen.prototype.translateOnQuerry = function ( data ){ return; };


Screen.prototype.generateOffQuerry  = function (){
    var command = Buffer.from ( '01302A304130430243323033443630303034031D0D' , 'hex');
    return command;
};
Screen.prototype.translateOffQuerry = function ( data ){ return; };


/******************************** FREE COMMAND: REBOOT PROTOTYPING ********************************/
Screen.prototype.singularRebootAvailable = true;
//Screen.prototype.allRebootAvailable = true;


/******************************** FREE COMMAND: CUSTOM PROTOTYPING ********************************/
Screen.prototype.generateFreeQuerry  = function ( commandRecived ){
    return Buffer.from ( commandRecived , 'hex');
    
};
Screen.prototype.translateFreeQuerry = function ( data ){ return; };
Screen.prototype.endFreeQuerry      = function (){ return; };




